/*--------------------------------------------------------------------------+
|                                                                          |
| Copyright 2022 fortiss GmbH          							           |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.tooling.ext.variability.compose;

import org.eclipse.emf.ecore.EObject;
import org.fortiss.tooling.kernel.extension.base.ElementCompositorBase;
import org.fortiss.tooling.kernel.extension.data.IElementCompositionContext;
import org.fortiss.variability.model.IAlternative;
import org.fortiss.variability.model.IAlternativeVariationPoint;

/**
 * Base class for compositors that compose {@link IAlternativeVariationPoint}. 
 * 
 * @author bayha
 */
public abstract class AlternativeVariationPointCompositorBase<T extends IAlternative>
		extends ElementCompositorBase<IAlternativeVariationPoint<T>> {

	/** {@inheritDoc} */
	@SuppressWarnings("unchecked")
	@Override
	public boolean compose(IAlternativeVariationPoint<T> container, EObject contained,
			IElementCompositionContext context) {
		return container.getAlternatives().add((T) contained);
	}
}
